## lxml 0.7

=== Makefile ===
PYTHON=python2.3
TESTFLAGS=-p -v
TESTOPTS=
SETUPFLAGS=

all: inplace

# Build in-place
inplace:
	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i

build:
	$(PYTHON) setup.py $(SETUPFLAGS) build

test_build: build
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)

test_inplace: inplace
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)

ftest_build: build
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

ftest_inplace: inplace
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

# XXX What should the default be?
test: test_inplace

ftest: ftest_inplace

clean:
	find . \( -name '*.o' -o -name '*.c' -o -name '*.so' -o -name '*.py[co]' -o -name '*.dll' \) -exec rm -f {} \;
	rm -rf build

realclean: clean
	rm -f TAGS
	$(PYTHON) setup.py clean -a

## lxml 1.1.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-PYTHON=python2.3
+PYTHON?=python
 TESTFLAGS=-p -v
 TESTOPTS=
 SETUPFLAGS=
@@ -17,6 +17,11 @@
 
 test_inplace: inplace
 	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)
+	PYTHONPATH=src $(PYTHON) selftest.py
+	PYTHONPATH=src $(PYTHON) selftest2.py
+
+bench_inplace: inplace
+	$(PYTHON) bench.py -i
 
 ftest_build: build
 	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)
@@ -24,13 +29,19 @@
 ftest_inplace: inplace
 	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)
 
+html:
+	mkdir -p doc/html
+	$(PYTHON) doc/mkhtml.py doc/html . `cat version.txt`
+
 # XXX What should the default be?
 test: test_inplace
+
+bench: bench_inplace
 
 ftest: ftest_inplace
 
 clean:
-	find . \( -name '*.o' -o -name '*.c' -o -name '*.so' -o -name '*.py[co]' -o -name '*.dll' \) -exec rm -f {} \;
+	find . \( -name '*.o' -o -name '*.c' -o -name '*.so' -o -name '*.py[cod]' -o -name '*.dll' \) -exec rm -f {} \;
 	rm -rf build
 
 realclean: clean

## lxml 2.2.6-1maemo1

=== debian/changelog ===
lxml (2.2.6-1maemo1) unstable; urgency=low

  * Import from squeeze 2.2.6-1
  * Avoid scratchbox python.
  * Remove architecture-specific flags.

 -- Lauro Moura <lauro.neto@openbossa.org>  Fri, 23 Jul 2010 10:39:58 -0300

lxml (2.2.6-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Mar 2010 11:32:29 +0100

lxml (2.2.4-1) unstable; urgency=low

  * New upstream version.
  * Build a python-lxml-doc package. Closes: #488258.
  * Tighten build dependency. Closes: #551698.

 -- Matthias Klose <doko@debian.org>  Sun, 03 Jan 2010 14:14:10 +0100

lxml (2.2.2-2) unstable; urgency=low

  * Call setup.py install with --install-layout=deb. Closes: #547831.

 -- Matthias Klose <doko@debian.org>  Fri, 09 Oct 2009 00:46:15 +0200

lxml (2.2.2-1) unstable; urgency=low

  * New upstream version. Closes: #525961.
    - Includes html5parser. Closes: #521714.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Aug 2009 09:09:23 +0200

lxml (2.1.5-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 06 Jan 2009 21:57:07 +0100

lxml (2.1.4-1) unstable; urgency=low

  * New upstream version.
  * Remove the build dependency on cython, because cython doesn't have
    support for python debug builds.

 -- Matthias Klose <doko@debian.org>  Sun, 04 Jan 2009 15:01:17 +0000

lxml (2.1.3-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 30 Nov 2008 14:36:53 +0000

lxml (2.1.2-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 28 Sep 2008 23:33:48 +0200

lxml (2.1.1-2.1maemo1) unstable; urgency=low

  * Import from Debian stable (lenny).
  * Put the pymaemo-developers mailing list address in "Maintainer" field and
    move original value to a separate field.
  * Disable build of python-lxml-dbg binary package.

 -- Bruno dos Santos de Araujo <bruno.araujo@openbossa.org>  Thu, 26 Nov 2009 10:55:36 -0400

lxml (2.1.1-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Generate src/lxml/lxml.*.[ch] from the .pyx files.
    Closes: #497324.

 -- Thomas Viehmann <tv@beamnet.de>  Wed, 10 Sep 2008 20:55:19 +0200

lxml (2.1.1-2) unstable; urgency=low

  * Fix import, when python-stats is installed (Andrew Deason).
    Closes: #497324.

 -- Matthias Klose <doko@debian.org>  Sat, 06 Sep 2008 12:34:24 +0000

lxml (2.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Jul 2008 00:22:27 +0200

lxml (2.1-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Fri, 18 Jul 2008 16:04:45 +0000

lxml (2.0.7-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 30 Jun 2008 23:41:38 +0200

lxml (2.0.6-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Jun 2008 01:46:44 +0200

lxml (2.0.5-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 10 May 2008 11:31:36 +0200

lxml (2.0.4-1) unstable; urgency=low

  * New upstream version.
    - Fixes crash with iterparse + root substitution. Closes: #473977.

 -- Matthias Klose <doko@debian.org>  Sat, 19 Apr 2008 00:59:06 +0200

lxml (2.0.3-1) unstable; urgency=low

  * New upstream version.
  * src/lxml/lxml.etree.{c,h}: Regenerated.

 -- Matthias Klose <doko@debian.org>  Sun, 30 Mar 2008 15:12:58 +0200

lxml (2.0.2-2) unstable; urgency=low

  * Fix crash when using XML schema in iterparse (free-while-still-in-use bug).
    Closes: #471840.

 -- Matthias Klose <doko@debian.org>  Mon, 24 Mar 2008 19:00:36 +0100

lxml (2.0.2-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Mar 2008 19:05:46 +0100

lxml (1.3.6-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 26 Jan 2008 22:33:10 +0100

lxml (1.3.4-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Oct 2007 14:22:05 +0200

lxml (1.3.3-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 01 Aug 2007 20:41:48 +0200

lxml (1.3.2-2) unstable; urgency=low

  * Build-depend on zlib1g-dev. Closes: #434591.

 -- Matthias Klose <doko@debian.org>  Wed, 25 Jul 2007 09:26:09 +0200

lxml (1.3.2-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 25 Jul 2007 02:02:51 +0200

lxml (1.2.1-1) unstable; urgency=low

  * New upstream version.
  * Merge changes from Ubuntu:
    - Build a python-lxml-dbg package.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Jun 2007 09:05:43 +0200

lxml (1.1.2-1) unstable; urgency=medium

  * New upstream version.
    - fix import of lxml.objectify. Closes: #401644.

 -- Matthias Klose <doko@debian.org>  Thu,  7 Dec 2006 19:24:53 +0100

lxml (1.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 24 Oct 2006 00:39:24 +0200

lxml (1.0.3-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 19 Aug 2006 22:37:14 +0200

lxml (1.0.2-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Fri,  7 Jul 2006 22:19:48 +0000

lxml (1.0.1-2) unstable; urgency=low

  * Add python-setuptools as a build dependency.

 -- Matthias Klose <doko@debian.org>  Sat, 17 Jun 2006 11:41:10 +0000

lxml (1.0.1-1) unstable; urgency=low

  * New upstream version.
  * Convert to new Python policy. Closes: #373460.

 -- Matthias Klose <doko@debian.org>  Fri, 16 Jun 2006 22:04:16 +0200

lxml (0.9.1-1) unstable; urgency=low

  * New upstream version (closes: #362415).

 -- Matthias Klose <doko@debian.org>  Fri, 14 Apr 2006 22:10:18 +0000

lxml (0.8-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 15 Dec 2005 22:36:10 +0100

lxml (0.7-1) unstable; urgency=low



=== debian/control ===
Source: lxml
Section: python
Priority: optional
Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 5.0.37.1), python-central (>= 0.6.1), python-all-dev (>= 2.4.5), python-all-dbg, python-pyrex (>= 0.9.4.1-1), libxml2-dev, libxslt1-dev, zlib1g-dev, cython
Build-Conflicts: python-pkg-resources
XS-Python-Version: all
Standards-Version: 3.8.3

Package: python-lxml
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Conflicts: python2.3-lxml, python2.4-lxml
Replaces: python2.3-lxml, python2.4-lxml
Provides: ${python:Provides}
Suggests: python-lxml-dbg
XB-Python-Version: ${python:Versions}
Description: pythonic binding for the libxml2 and libxslt libraries
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from these existing Python bindings. Its aim:
 .
   * Pythonic API.
   * Documented.
   * Use Python unicode strings in API.
   * Safe (no segfaults).
   * No manual memory management!
 .
 lxml aims to provide a Pythonic API by following as much as possible
 the ElementTree API, trying to avoid having to invent too many new APIs,
 or you having to learn new things -- XML is complicated enough.

Package: python-lxml-dbg
Priority: extra
Section: debug
Architecture: any
Depends: python-lxml (= ${binary:Version}), python-dbg, ${shlibs:Depends}, ${misc:Depends}
Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from these existing Python bindings.
 .
 This package contains the extension built for the Python debug interpreter.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# avoid scratchbox python
PATH :=/usr/bin:$(PATH)
export PATH
SBOX_REDIRECT_IGNORE = /usr/bin/python
export SBOX_REDIRECT_IGNORE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYVERS	:= $(shell pyversions -vs)
PYVER   := $(shell pyversions -vd)

UPSTREAMVER := $(subst lxml-,,$(notdir $(CURDIR)))

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

include /usr/share/python/python.mk

prebuild: prebuild-stamp
prebuild-stamp: src/lxml/lxml.etree.pyx src/lxml/lxml.objectify.pyx
#	cython src/lxml/lxml.etree.pyx src/lxml/lxml.objectify.pyx
	touch $@

build: build-stamp
build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%)
	touch $@
build-python%: prebuild
	python$* setup.py build
	touch $@
dbg-build-python%: prebuild
	python$*-dbg setup.py build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp build-python* dbg-build-python* prebuild-stamp
	rm -rf build dist
#	rm -f src/lxml/lxml.etree_api.h src/lxml/lxml.etree.c \
#	      src/lxml/lxml.etree.h src/lxml/lxml.objectify.c

	-find -name '*.py[co]' | xargs rm -f
	rm -rf [23].[0-9]
	rm -f src/lxml/lxml-version.h
	dh_clean 

install: build install-prereq $(PYVERS:%=install-python%) $(PYVERS:%=dbg-install-python%)
	-find debian -name '*.py[co]' | xargs rm -f

install-prereq:
	dh_testdir
	dh_testroot
	dh_clean -k

install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml/$(call py_libdir, $*)
	python$* setup.py install \
		--root=$(CURDIR)/debian/python-lxml

dbg-install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml-dbg/$(call py_libdir, $*)
	python$*-dbg setup.py install \
		--root=$(CURDIR)/debian/python-lxml-dbg
	find debian/python-*-dbg ! -type d ! -name '*.so' | xargs rm -f
	find debian/python-*-dbg -depth -empty -exec rmdir {} \;

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installexamples -i samples/*
	dh_compress -i -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a CHANGES.txt
	dh_installdocs -a CREDITS.txt README.txt TODO.txt
	dh_installexamples -a samples/*
	dh_strip -ppython-lxml --dbg-package=python-lxml-dbg
	rm -rf debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	ln -s python-lxml debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	dh_compress -a -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -a
	dh_pycentral -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
http://codespeak.net/lxml/index.html lxml-(.*)\.tgz

## lxml 3.2.5

=== debian/changelog ===
lxml (3.2.5-1tanglu0.1) aequorea-updates; urgency=medium

  * New upstream version.
  * Add patch for CVE-2014-3146.

 -- Jon Severinsson <jon@severinsson.net>  Sun, 01 May 2014 10:00:00 +0200

lxml (3.2.0-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 11 May 2013 16:53:02 +0200

lxml (3.1.0-1) experimental; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 19 Feb 2013 21:47:31 +0100

lxml (3.1~beta1-1) experimental; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Jan 2013 22:14:53 +0100

lxml (3.0.1-1) experimental; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 21 Oct 2012 19:29:34 +0200

lxml (2.3.5-1) unstable; urgency=low

  * New upstream version.
    - Features added:
      * lxml.html.tostring() gained new serialisation options
        ``with_tail`` and ``doctype``.
    - Bugs fixed:
      * Crash when merging text nodes in ``element.remove()``.
      * Crash in sax/target parser when reporting empty doctype.
      * Crash when building an nsmap (Element property) with empty
        namespace URIs.
      * Crash due to race condition when errors (or user messages) occur
        during threaded XSLT processing.
      * XSLT stylesheet compilation could ignore compilation errors.
      * Fixed a crash when using ``iterparse()`` for HTML parsing and
        requesting start events.
      * Fixed parsing of more selectors in cssselect.  Whitespace before
        pseudo-elements and pseudo-classes is significant as it is a
        descendant combinator.
      * lxml.html.diff no longer raises an exception when hitting
        'img' tags without 'src' attribute.

 -- Matthias Klose <doko@debian.org>  Mon, 17 Sep 2012 13:29:26 +0200

lxml (2.3.2-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 04 Jan 2012 13:29:53 +0100

lxml (2.3-0.1) unstable; urgency=low

  * Upload 2.3 final to unstable as NMU at maintainer request

 -- Scott Kitterman <scott@kitterman.com>  Mon, 07 Mar 2011 13:17:25 -0500

lxml (2.3~beta1-1) experimental; urgency=low

  * lxml-2.3 beta1 release.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Dec 2010 13:07:46 +0100

lxml (2.3~alpha2-1) experimental; urgency=low

  * lxml-2.3 alpha2 release.
    - Fix build failure with python3.2.

 -- Matthias Klose <doko@debian.org>  Mon, 18 Oct 2010 18:05:26 +0200

lxml (2.2.8-2) unstable; urgency=low

  * Add copyright and license information for test.py. Closes: #597547.
  * Build using distribute.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Sep 2010 19:42:55 +0200

lxml (2.2.8-1) experimental; urgency=low

  * New upstream version (bug fix release):
    - Crash in newer libxml2 versions when moving elements between
      documents that had attributes on replaced XInclude nodes.

 -- Matthias Klose <doko@debian.org>  Sun, 12 Sep 2010 19:10:50 +0200

lxml (2.2.7-1) experimental; urgency=low

  * New upstream version (bug fix release):
    - Crash in XSLT when generating text-only result documents with a
      stylesheet created in a different thread.
  * Build python3 packages. Closes: #589333.
  * Update package description. Closes: #579246.
  * Remove empty directory from package: Closes: #569687.

 -- Matthias Klose <doko@debian.org>  Sun, 12 Sep 2010 19:07:32 +0200

=== debian/control ===
Source: lxml
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 5.0.37.1), python-all-dev (>= 2.6.6-1~), python-all-dbg, python3-all-dev (>= 3.1.2-10~), python3-all-dbg, python-pyrex (>= 0.9.4.1), libxml2-dev, libxslt1-dev, zlib1g-dev, python-setuptools, python3-setuptools (>= 0.6.29)
X-Python-Version: all
Standards-Version: 3.9.4
Homepage: http://codespeak.net/lxml/

Package: python-lxml
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Conflicts: python2.3-lxml, python2.4-lxml
Replaces: python2.3-lxml, python2.4-lxml
Provides: ${python:Provides}
Suggests: python-lxml-dbg
Description: pythonic binding for the libxml2 and libxslt libraries
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings. Its aim:
 .
   * Pythonic API.
   * Documented.
   * Use Python unicode strings in API.
   * Safe (no segfaults).
   * No manual memory management!
 .
 lxml aims to provide a Pythonic API by following as much as possible
 the ElementTree API, trying to avoid inventing too many new APIs,
 or the user's having to learn new things -- XML is complicated enough.

Package: python-lxml-dbg
Priority: extra
Section: debug
Architecture: any
Depends: python-lxml (= ${binary:Version}), python-dbg, ${shlibs:Depends}, ${misc:Depends}
Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-lxml
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3-lxml-dbg
Provides: ${python3:Provides}
Description: pythonic binding for the libxml2 and libxslt libraries
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings. Its aim:
 .
   * Pythonic API.
   * Documented.
   * Use Python unicode strings in API.
   * Safe (no segfaults).
   * No manual memory management!
 .
 lxml aims to provide a Pythonic API by following as much as possible
 the ElementTree API, trying to avoid inventing too many new APIs,
 or the user's having to learn new things -- XML is complicated enough.

Package: python3-lxml-dbg
Priority: extra
Section: debug
Architecture: any
Depends: python3-lxml (= ${binary:Version}), python3-dbg, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings.
 .
 This package contains the extension built for the Python3 debug interpreter.

Package: python-lxml-doc
Priority: extra
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: python-lxml
Description: pythonic binding for the libxml2 and libxslt libraries (documentation)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from these existing Python bindings.
 .
 This package contains the html documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYVERS	:= $(shell pyversions -vs)
PYVER	:= $(shell pyversions -vd)

PY3VERS	:= $(shell py3versions -vs)
PY3VER	:= $(shell py3versions -vd)

UPSTREAMVER := $(subst lxml-,,$(notdir $(CURDIR)))

include /usr/share/python3/python.mk

prebuild: prebuild-stamp
prebuild-stamp: src/lxml/lxml.etree.pyx src/lxml/lxml.objectify.pyx
#	cython src/lxml/lxml.etree.pyx src/lxml/lxml.objectify.pyx
	touch $@

build-arch: build
build-indep: build
build: build-stamp build3-stamp
build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%)
	touch $@
build-python%: prebuild
	python$* setup.py build
	touch $@
dbg-build-python%: prebuild
	python$*-dbg setup.py build
	touch $@

build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
	touch $@
build3-python%: prebuild
	python$* setup.py build
	touch $@
dbg-build3-python%: prebuild
	python$*-dbg setup.py build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp
	rm -rf build dist __pycache__
#	rm -f src/lxml/lxml.etree_api.h src/lxml/lxml.etree.c \
#	      src/lxml/lxml.etree.h src/lxml/lxml.objectify.c

	-find -name '*.py[co]' | xargs rm -f
	rm -rf [23].[0-9]
	rm -f src/lxml/lxml-version.h
	dh_clean 

install: build install-prereq $(PYVERS:%=install-python%) $(PYVERS:%=dbg-install-python%) $(PY3VERS:%=install3-python%) $(PY3VERS:%=dbg-install3-python%)
	-find debian -name '*.py[co]' | xargs rm -f
	-find debian -name __pycache__ | xargs rm -rf
	rm -rf debian/python*-lxml/usr/lib/python

install-prereq:
	dh_testdir
	dh_testroot
	dh_clean -k

install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml/$(call py_libdir, $*)
	python$* setup.py install \
		--root=$(CURDIR)/debian/python-lxml --install-layout=deb

dbg-install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml-dbg/$(call py_libdir, $*)
	python$*-dbg setup.py install \
		--root=$(CURDIR)/debian/python-lxml-dbg --install-layout=deb
	find debian/python-*-dbg ! -type d ! -name '*.so' | xargs rm -f
	find debian/python-*-dbg -depth -empty -exec rmdir {} \;

install3-python%:
	mkdir -p debian/python3-lxml/usr/bin
	mkdir -p debian/python3-lxml/$(call py_libdir, $*)
	python$* setup.py install \
		--root=$(CURDIR)/debian/python3-lxml --install-layout=deb

dbg-install3-python%:
	mkdir -p debian/python3-lxml/usr/bin
	mkdir -p debian/python3-lxml-dbg/$(call py_libdir, $*)
	python$*-dbg setup.py install \
		--root=$(CURDIR)/debian/python3-lxml-dbg --install-layout=deb
	find debian/python3-*-dbg ! -type d ! -name '*.so' | xargs rm -f
	find debian/python3-*-dbg -depth -empty -exec rmdir {} \;

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -i
	mkdir -p debian/python-lxml-doc/usr/share/doc/python-lxml
	cp -r doc/html debian/python-lxml-doc/usr/share/doc/python-lxml/
	ln -sf ../python-lxml/html debian/python-lxml-doc/usr/share/doc/python-lxml-doc/html
	dh_installexamples -i samples/*
	dh_compress -i -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a CHANGES.txt
	dh_installdocs -a CREDITS.txt README.rst TODO.txt
	dh_installexamples -a samples/*
	dh_python2 -a
	dh_python3 -a
	dh_strip -ppython-lxml --dbg-package=python-lxml-dbg
	rm -rf debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	ln -s python-lxml debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	dh_strip -ppython3-lxml --dbg-package=python3-lxml-dbg
	rm -rf debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg
	ln -s python3-lxml debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg
	dh_compress -a -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## lxml 3.3.1

=== Makefile ===
PYTHON?=python
PYTHON3?=python3
TESTFLAGS=-p -v
TESTOPTS=
SETUPFLAGS=
LXMLVERSION=`cat version.txt`

PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)
PY3_WITH_CYTHON=$(shell $(PYTHON3) -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)

all: inplace

# Build in-place
inplace:
	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON)

sdist:
	$(PYTHON) setup.py $(SETUPFLAGS) sdist $(PYTHON_WITH_CYTHON)

build:
	$(PYTHON) setup.py $(SETUPFLAGS) build $(PYTHON_WITH_CYTHON)

wheel:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON)

wheel_static:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON) --static-deps

test_build: build
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)

test_inplace: inplace
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) selftest.py
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) selftest2.py

test_inplace3: inplace
	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON)
	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS)
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON3) selftest.py
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON3) selftest2.py

valgrind_test_inplace: inplace
	valgrind --tool=memcheck --leak-check=full --num-callers=30 --suppressions=valgrind-python.supp \
		$(PYTHON) test.py

gdb_test_inplace: inplace
	@echo -e "file $(PYTHON)\nrun test.py" > .gdb.command
	gdb -x .gdb.command -d src -d src/lxml

bench_inplace: inplace
	$(PYTHON) benchmark/bench_etree.py -i
	$(PYTHON) benchmark/bench_xpath.py -i
	$(PYTHON) benchmark/bench_xslt.py -i
	$(PYTHON) benchmark/bench_objectify.py -i

ftest_build: build
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

ftest_inplace: inplace
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

apihtml: inplace
	rm -fr doc/html/api
	@[ -x "`which epydoc`" ] \
		&& (cd src && echo "Generating API docs ..." && \
			PYTHONPATH=. epydoc -v --docformat "restructuredtext en" \
			-o ../doc/html/api --exclude='[.]html[.]tests|[.]_' \
			--exclude-introspect='[.]usedoctest' \
			--name "lxml API" --url / lxml/) \
		|| (echo "not generating epydoc API documentation")

website: inplace
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) doc/mkhtml.py doc/html . ${LXMLVERSION}

html: inplace website apihtml s5

s5:
	$(MAKE) -C doc/s5 slides

apipdf: inplace
	rm -fr doc/pdf
	mkdir -p doc/pdf
	@[ -x "`which epydoc`" ] \
		&& (cd src && echo "Generating API docs ..." && \
			PYTHONPATH=. epydoc -v --latex --docformat "restructuredtext en" \
			-o ../doc/pdf --exclude='([.]html)?[.]tests|[.]_' \
			--exclude-introspect='html[.]clean|[.]usedoctest' \
			--name "lxml API" --url / lxml/) \
		|| (echo "not generating epydoc API documentation")

pdf: apipdf
	$(PYTHON) doc/mklatex.py doc/pdf . ${LXMLVERSION}
	(cd doc/pdf && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex)
	@cp doc/pdf/lxmldoc.pdf doc/pdf/lxmldoc-${LXMLVERSION}.pdf
	@echo "PDF available as doc/pdf/lxmldoc-${LXMLVERSION}.pdf"

# Two pdflatex runs are needed to build the correct Table of contents.

test: test_inplace

test3: test_inplace3

valtest: valgrind_test_inplace

gdbtest: gdb_test_inplace

bench: bench_inplace

ftest: ftest_inplace

clean:
	find . \( -name '*.o' -o -name '*.so' -o -name '*.py[cod]' -o -name '*.dll' \) -exec rm -f {} \;
	rm -rf build

docclean:
	$(MAKE) -C doc/s5 clean
	rm -f doc/html/*.html
	rm -fr doc/html/api
	rm -fr doc/pdf

realclean: clean docclean
	find src -name '*.c' -exec rm -f {} \;
	rm -f TAGS
	$(PYTHON) setup.py clean -a --without-cython

## lxml 3.4.0

=== debian/changelog ===
lxml (3.4.0-1+deb8u2) jessie-security; urgency=high

  [ Utkarsh Gupta ]
   * Non-maintainer upload by the Debian ELTS Team.
   * CVE-2020-27783: Prevent combinations of <noscript> and <style> to
     sneak JavaScript through the HTML cleaner.

  [ Emilio Pozuelo Monfort ]
  * Switch to source format 3.0 so both the above patch and the previous
    one for CVE-2018-19787 get applied, which weren't before as there was
    no patch system. Thus this change additionally fixes CVE-2018-19787,
    which was shipped but wasn't applied in the previous update.
  * Run the test suite, but ignore failures for now.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Mon, 30 Nov 2020 13:23:00 +0100

lxml (3.4.0-1+deb8u1) jessie-security; urgency=high

  * CVE-2018-19787: Prevent an XSS injection vulnerability where LXML did not
    remove "javascript:" URLs that used escaping.

 -- Chris Lamb <lamby@debian.org>  Mon, 10 Dec 2018 09:39:10 +0100

lxml (3.4.0-1) unstable; urgency=medium

  * New upstream version 3.4.0.

 -- Matthias Klose <doko@debian.org>  Thu, 11 Sep 2014 21:17:44 +0200

lxml (3.3.6-0ubuntu1) utopic; urgency=medium

  * New upstrea version 3.3.6.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Sep 2014 21:02:59 +0200

lxml (3.3.5-1) unstable; urgency=medium

  * New upstrea version 3.3.5.

 -- Matthias Klose <doko@debian.org>  Sun, 18 May 2014 20:03:12 +0200

lxml (3.3.2-1) unstable; urgency=medium

  * New upstrea version 3.3.2.
    - Re-add lost properties of iterparse objects. Closes: #740226,
      #740102.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 03 Mar 2014 23:22:35 +0100

lxml (3.3.1-1) unstable; urgency=medium

  * New upstream version 3.3.1.

 -- Matthias Klose <doko@debian.org>  Mon, 17 Feb 2014 11:20:43 +0100

lxml (3.3.0~beta4-1) experimental; urgency=medium

  * New upstream version 3.3.0 beta4.
  * Update homepage. Closes: #698851.

 -- Matthias Klose <doko@debian.org>  Tue, 14 Jan 2014 09:27:36 +0100

lxml (3.3.0~beta2-1) experimental; urgency=low

  * New upstream version 3.3.0 beta2.

 -- Matthias Klose <doko@debian.org>  Thu, 26 Dec 2013 00:37:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,20 @@
 Section: python
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 5.0.37.1), python-all-dev (>= 2.6.6-1~), python-all-dbg, python3-all-dev (>= 3.1.2-10~), python3-all-dbg, python-pyrex (>= 0.9.4.1), libxml2-dev, libxslt1-dev, zlib1g-dev, python-setuptools, python3-setuptools (>= 0.6.29)
+Build-Depends: debhelper (>= 5.0.37.1),
+  python-all-dev (>= 2.6.6-1~), python-all-dbg,
+  python3-all-dev (>= 3.3.3), python3-all-dbg,
+  python-pyrex (>= 0.9.4.1),
+  libxml2-dev, libxslt1-dev, zlib1g-dev,
+  python-setuptools, python3-setuptools (>= 0.6.29)
+Build-Conflicts: cython
 X-Python-Version: all
-Standards-Version: 3.9.4
-Homepage: http://codespeak.net/lxml/
+Standards-Version: 3.9.5
+Homepage: http://lxml.de/
 
 Package: python-lxml
 Architecture: any
 Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
-Conflicts: python2.3-lxml, python2.4-lxml
-Replaces: python2.3-lxml, python2.4-lxml
 Provides: ${python:Provides}
 Suggests: python-lxml-dbg
 Description: pythonic binding for the libxml2 and libxslt libraries

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 build-arch: build
 build-indep: build
 build: build-stamp build3-stamp
-build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%)
+build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%) $(PYVERS:%=check-python%)
 	touch $@
 build-python%: prebuild
 	python$* setup.py build
@@ -31,13 +31,20 @@
 	python$*-dbg setup.py build
 	touch $@
 
-build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
+build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%) $(PY3VERS:%=check-python%)
 	touch $@
 build3-python%: prebuild
 	python$* setup.py build
 	touch $@
 dbg-build3-python%: prebuild
 	python$*-dbg setup.py build
+	touch $@
+
+check-python%:
+	python$* setup.py build_ext -i
+	-python$* test.py -vv
+	#python$*-dbg setup.py build_ext -i
+	#-python$*-dbg test.py -vv
 	touch $@
 
 clean:

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/ \
http://pypi.python.org/packages/source/l/lxml/lxml-(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))

## lxml 3.7.1

=== Makefile ===
--- 
+++ 
@@ -3,22 +3,51 @@
 TESTFLAGS=-p -v
 TESTOPTS=
 SETUPFLAGS=
-LXMLVERSION=`cat version.txt`
+LXMLVERSION=$(shell cat version.txt)
 
-PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)
-PY3_WITH_CYTHON=$(shell $(PYTHON3) -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)
+PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
+PY3_WITH_CYTHON=$(shell $(PYTHON3) -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
+CYTHON_WITH_COVERAGE=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
+CYTHON3_WITH_COVERAGE=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
+
+MANYLINUX_LIBXML2_VERSION=2.9.3
+MANYLINUX_LIBXSLT_VERSION=1.1.29
+MANYLINUX_IMAGE_X86_64=quay.io/pypa/manylinux1_x86_64
+
+.PHONY: all inplace rebuild-sdist sdist build require-cython wheel_manylinux wheel
 
 all: inplace
 
 # Build in-place
 inplace:
-	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON)
+	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON) --warnings --with-coverage
 
-sdist:
+rebuild-sdist: require-cython
+	rm -f dist/lxml-$(LXMLVERSION).tar.gz
+	find src -name '*.c' -exec rm -f {} \;
+	$(MAKE) dist/lxml-$(LXMLVERSION).tar.gz
+
+dist/lxml-$(LXMLVERSION).tar.gz:
 	$(PYTHON) setup.py $(SETUPFLAGS) sdist $(PYTHON_WITH_CYTHON)
+
+sdist: dist/lxml-$(LXMLVERSION).tar.gz
 
 build:
 	$(PYTHON) setup.py $(SETUPFLAGS) build $(PYTHON_WITH_CYTHON)
+
+require-cython:
+	@[ -n "$(PYTHON_WITH_CYTHON)" ] || { \
+	    echo "NOTE: missing Cython - please use this command to install it: $(PYTHON) -m pip install Cython"; false; }
+
+wheel_manylinux: dist/lxml-$(LXMLVERSION).tar.gz
+	time docker run --rm -t \
+		-v $(shell pwd):/io \
+		-e CFLAGS="-O3 -mtune=generic -pipe -fPIC" \
+		-e LDFLAGS="$(LDFLAGS)" \
+		-e LIBXML2_VERSION="$(MANYLINUX_LIBXML2_VERSION)" \
+		-e LIBXSLT_VERSION="$(MANYLINUX_LIBXSLT_VERSION)" \
+		$(MANYLINUX_IMAGE_X86_64) \
+		bash /io/tools/manylinux/build-wheels.sh /io/$<
 
 wheel:
 	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON)
@@ -30,15 +59,11 @@
 	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)
 
 test_inplace: inplace
-	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)
-	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) selftest.py
-	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) selftest2.py
+	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON_WITH_COVERAGE)
 
 test_inplace3: inplace
 	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON)
-	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS)
-	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON3) selftest.py
-	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON3) selftest2.py
+	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON3_WITH_COVERAGE)
 
 valgrind_test_inplace: inplace
 	valgrind --tool=memcheck --leak-check=full --num-callers=30 --suppressions=valgrind-python.supp \

=== debian/changelog ===
lxml (3.7.1-1+deb9u5) stretch-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * Add patch to prevent "@import" from re-occurring in the
    CSS after replacements, e.g. "@@importimport" and remove
    SVG image data URLs since they can embed script content.
    (Fixes: CVE-2021-43818) (Closes: #1001885)

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 29 Dec 2021 19:08:30 +0530

lxml (3.7.1-1+deb9u4) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2021-28957
    Due to missing input sanitization, XSS is possible for the HTML5
    formatcion attribute.

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 23 Mar 2021 19:03:02 +0100

lxml (3.7.1-1+deb9u3) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * Enable the test suite (non-fatal).
  * Switch to source format 3.0 (quilt), rather than having the patches
    in debian/patches/ but applied directly without a patch system.
  * Fix regression in Python 2 in the last part of CVE-2020-27783.
  * math-svg.patch: update expected results for the test suite.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Fri, 18 Dec 2020 09:50:10 +0100

lxml (3.7.1-1+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * CVE-2020-27783: Backport additional upstream commit
    a105ab8dc262ec6735977c25c13f0bdfcdec72a7 to address math/svg part of the
    vulnerability and complete the fix

 -- Roberto C. Sánchez <roberto@debian.org>  Tue, 15 Dec 2020 13:23:34 -0500

lxml (3.7.1-1+deb9u1) stretch-security; urgency=medium

  * Non-maintainer upload by the Debian LTS Team.
  * CVE-2018-19787: lxml/html/clean.py in the lxml.html.clean module
    does not remove javascript: URLs that use escaping.
  * CVE-2020-27783: Prevent combinations of <noscript> and <style> to
    sneak JavaScript through the HTML cleaner.

 -- Abhijith PA <abhijith@debian.org>  Thu, 26 Nov 2020 18:38:23 +0530

lxml (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1.

 -- Matthias Klose <doko@debian.org>  Thu, 05 Jan 2017 19:55:57 +0100

lxml (3.6.4-1) unstable; urgency=medium

  * New upstream version 3.6.4.

 -- Matthias Klose <doko@debian.org>  Wed, 24 Aug 2016 10:14:49 +0200

lxml (3.6.0-1) unstable; urgency=medium

  * New upstream version 3.6.0.

 -- Matthias Klose <doko@debian.org>  Tue, 29 Mar 2016 13:19:30 +0100

lxml (3.5.0-1) unstable; urgency=medium

  * New upstream version 3.5.0.

 -- Matthias Klose <doko@debian.org>  Fri, 04 Dec 2015 13:03:31 +0100

lxml (3.4.4-2) unstable; urgency=medium

  * Update watch file.
  * Build using cython. Closes: #792295.

 -- Matthias Klose <doko@debian.org>  Sun, 13 Sep 2015 14:21:16 +0200

lxml (3.4.4-1) unstable; urgency=medium

  * New upstream version 3.4.4.

 -- Matthias Klose <doko@debian.org>  Mon, 03 Aug 2015 14:13:30 +0200

lxml (3.4.2-1) unstable; urgency=medium

  * New upstream version 3.4.2.
  * python-lxml, python3-lxml: Suggest python-lxml-doc. Closes: #741214.
  * Build-depend on python-bs4 python3-bs4 python-html5lib python3-html5lib.
  * python-lxml: Recommend python-bs4, python-html5lib.
  * python3-lxml: Recommend python3-bs4, python3-html5lib.

 -- Matthias Klose <doko@debian.org>  Fri, 27 Feb 2015 05:11:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,25 @@
 Section: python
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 5.0.37.1),
+Build-Depends: debhelper (>= 9),
   python-all-dev (>= 2.6.6-1~), python-all-dbg,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
   python-pyrex (>= 0.9.4.1),
   libxml2-dev, libxslt1-dev, zlib1g-dev,
-  python-setuptools, python3-setuptools (>= 0.6.29)
-Build-Conflicts: cython
+  python-setuptools, python3-setuptools (>= 0.6.29),
+  python-bs4, python3-bs4,
+  python-html5lib, python3-html5lib,
+  cython, cython-dbg, cython3, cython3-dbg
 X-Python-Version: all
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: http://lxml.de/
 
 Package: python-lxml
 Architecture: any
 Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
 Provides: ${python:Provides}
-Suggests: python-lxml-dbg
+Recommends: python-bs4, python-html5lib
+Suggests: python-lxml-dbg, python-lxml-doc
 Description: pythonic binding for the libxml2 and libxslt libraries
  lxml is a new Python binding for libxml2 and libxslt, completely
  independent from existing Python bindings. Its aim:
@@ -46,7 +49,8 @@
 Package: python3-lxml
 Architecture: any
 Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
-Suggests: python3-lxml-dbg
+Recommends: python3-bs4, python3-html5lib
+Suggests: python3-lxml-dbg, python-lxml-doc
 Provides: ${python3:Provides}
 Description: pythonic binding for the libxml2 and libxslt libraries
  lxml is a new Python binding for libxml2 and libxslt, completely
@@ -78,6 +82,7 @@
 Priority: extra
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: python-lxml
 Description: pythonic binding for the libxml2 and libxslt libraries (documentation)

=== debian/rules ===
--- 
+++ 
@@ -68,7 +68,7 @@
 install-prereq:
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 
 install-python%:
 	mkdir -p debian/python-lxml/usr/bin

## lxml 4.0.0

=== debian/changelog ===
lxml (4.0.0-1) unstable; urgency=medium

  * New upstream version 4.0.0.

 -- Matthias Klose <doko@debian.org>  Sat, 23 Sep 2017 12:01:24 +0200

lxml (3.8.0-2) unstable; urgency=medium

  * Rebuild against pythonX.Y packages without the _fpectl extension.
    Addresses: #873899.

 -- Matthias Klose <doko@debian.org>  Fri, 01 Sep 2017 07:53:12 +0200

lxml (3.8.0-1) unstable; urgency=medium

  * New upstream version 3.8.0.

 -- Matthias Klose <doko@debian.org>  Tue, 20 Jun 2017 15:25:39 +0200

lxml (3.7.3-1) unstable; urgency=medium

  * New upstream version 3.7.3.
    - GH#218 was ineffective in Python 3.
    - GH#222: ``lxml.html.submit_form()`` failed in Python 3.
    - GH#220: ``xmlfile`` allows switching output methods at an element level.
    - Work around installation problems in recent Python 2.7 versions
      due to FTP download failures.
    - GH#219: ``xmlfile.element()`` was not properly quoting attribute values.
    - GH#218: ``xmlfile.element()`` was not properly escaping text content of
      script/style tags.

 -- Matthias Klose <doko@debian.org>  Sun, 26 Feb 2017 18:51:56 +0100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9),
+  dh-python,
   python-all-dev (>= 2.6.6-1~), python-all-dbg,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
   python-pyrex (>= 0.9.4.1),
@@ -10,9 +11,9 @@
   python-setuptools, python3-setuptools (>= 0.6.29),
   python-bs4, python3-bs4,
   python-html5lib, python3-html5lib,
-  cython, cython-dbg, cython3, cython3-dbg
+  cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.1.0

=== Makefile ===
--- 
+++ 
@@ -10,17 +10,21 @@
 CYTHON_WITH_COVERAGE=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
 CYTHON3_WITH_COVERAGE=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
 
-MANYLINUX_LIBXML2_VERSION=2.9.3
-MANYLINUX_LIBXSLT_VERSION=1.1.29
+MANYLINUX_LIBXML2_VERSION=2.9.5
+MANYLINUX_LIBXSLT_VERSION=1.1.30
 MANYLINUX_IMAGE_X86_64=quay.io/pypa/manylinux1_x86_64
+MANYLINUX_IMAGE_686=quay.io/pypa/manylinux1_i686
 
-.PHONY: all inplace rebuild-sdist sdist build require-cython wheel_manylinux wheel
+.PHONY: all inplace inplace3 rebuild-sdist sdist build require-cython wheel_manylinux wheel
 
 all: inplace
 
 # Build in-place
 inplace:
 	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON) --warnings --with-coverage
+
+inplace3:
+	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON) --warnings --with-coverage
 
 rebuild-sdist: require-cython
 	rm -f dist/lxml-$(LXMLVERSION).tar.gz
@@ -39,14 +43,17 @@
 	@[ -n "$(PYTHON_WITH_CYTHON)" ] || { \
 	    echo "NOTE: missing Cython - please use this command to install it: $(PYTHON) -m pip install Cython"; false; }
 
-wheel_manylinux: dist/lxml-$(LXMLVERSION).tar.gz
+wheel_manylinux: wheel_manylinux64 wheel_manylinux32
+
+wheel_manylinux32 wheel_manylinux64: dist/lxml-$(LXMLVERSION).tar.gz
 	time docker run --rm -t \
 		-v $(shell pwd):/io \
-		-e CFLAGS="-O3 -mtune=generic -pipe -fPIC" \
-		-e LDFLAGS="$(LDFLAGS)" \
+		-e CFLAGS="-O3 -g1 -mtune=generic -pipe -fPIC -flto" \
+		-e LDFLAGS="$(LDFLAGS) -flto" \
 		-e LIBXML2_VERSION="$(MANYLINUX_LIBXML2_VERSION)" \
 		-e LIBXSLT_VERSION="$(MANYLINUX_LIBXSLT_VERSION)" \
-		$(MANYLINUX_IMAGE_X86_64) \
+		-e WHEELHOUSE=wheelhouse_$(subst wheel_,,$@) \
+		$(if $(patsubst %32,,$@),$(MANYLINUX_IMAGE_X86_64),$(MANYLINUX_IMAGE_686)) \
 		bash /io/tools/manylinux/build-wheels.sh /io/$<
 
 wheel:
@@ -61,8 +68,7 @@
 test_inplace: inplace
 	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON_WITH_COVERAGE)
 
-test_inplace3: inplace
-	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON)
+test_inplace3: inplace3
 	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON3_WITH_COVERAGE)
 
 valgrind_test_inplace: inplace

=== debian/changelog ===
lxml (4.1.0-1~mx17+1) mx; urgency=medium

  * Rebuild for MX-17.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 09 Jan 2018 13:53:11 -0800

lxml (4.1.0-1) unstable; urgency=medium

  * New upstream version 4.1.0.

 -- Matthias Klose <doko@debian.org>  Wed, 01 Nov 2017 05:55:16 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+Bugs: mailto: <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9),
   dh-python,
   python-all-dev (>= 2.6.6-1~), python-all-dbg,
@@ -13,7 +15,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.1.0
+Standards-Version: 4.1.1
 Homepage: http://lxml.de/
 
 Package: python-lxml
